//----------------------------------------------------------------------------------------------
// BSP : Seeed nRF52 Borads 1.1.8
// Board : Seeed nRF52 Boards / Seeed XIAO nRF52840 Sense
//----------------------------------------------------------------------------------------------
// Comparison of current consumption when Advertising MSD 
// MSD 8 bytes data
// TxPower 4dBm, DCDC, on-board Flash off
// Advertise 10 times during 1 second and LightSleep for 59 seconds

// 2025/01/16

#include <bluefruit.h>
#include <Adafruit_SPIFlash.h>

// advertising data
uint8_t adv_data[] = { 0xFF, 0xFF,                        /* Manufacture ID */
                       0x02, 0x03, 0x04, 0x05, 0x06, 0x07 /* Sample data */
                      };
                         
void startAdv(void)
{  

  Bluefruit.Advertising.addData(BLE_GAP_AD_TYPE_MANUFACTURER_SPECIFIC_DATA, adv_data, sizeof(adv_data)/sizeof(adv_data[0]));
//  Bluefruit.Advertising.setType(BLE_GAP_ADV_TYPE_NONCONNECTABLE_NONSCANNABLE_UNDIRECTED);  // for XIAO BLE
  Bluefruit.Advertising.setType(BLE_GAP_ADV_TYPE_CONNECTABLE_SCANNABLE_UNDIRECTED);   // for mobile tool
  Bluefruit.Advertising.restartOnDisconnect(true);
  Bluefruit.Advertising.setIntervalMS(100, 100);    // in unit of ms
  Bluefruit.Advertising.setFastTimeout(1);          // number of seconds in fast mode
  Bluefruit.Advertising.start(1);                   // stop advertising after 1 seconds
}


void setup()
{
  // Shut down unused QSPI flash memory
  Adafruit_FlashTransport_QSPI flashTransport;
  flashTransport.begin();
  flashTransport.runCommand(0xB9);
  flashTransport.end();

  // Enable DC-DC converter
  NRF_POWER->DCDCEN = 1;

  Bluefruit.begin();
  Bluefruit.setName("XIAO_nRF52840");
  Bluefruit.autoConnLed(false); // turn off LED to save power
  Bluefruit.setTxPower(4);      // -40, -20, -16, -12, -8, -4, 0, +2, +3, +4, +5, +6, +7, +8
  startAdv();
}

void loop()
{
  startAdv();
  delay(59000);  // advertising period = 59s
  Bluefruit.Advertising.clearData();  // refresh advertising data for each cycle
}
